# -*- perl -*-
#
# Copyright (C) 2004-2006 Daniel P. Berrange
#

package Net::WMI::ClassObject;

use 5.006;
use strict;
use warnings;

=item my $msg = Net::DBus::Binding::Message->new(message => $rawmessage);

Creates a new message object, initializing it with the underlying C
message object given by the C<message> object. This constructor is
intended for internal use only, instead refer to one of the four
sub-types for this class for specific message types

=cut

sub new {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my %params = @_;
    my $self = {};

    $self->{obj} = exists $params{obj} ? $params{obj} : die "obj parameter is required";

    bless $self, $class;

    return $self;
}

sub GetMethod {
    my $self = shift;
}

sub GetClassName {
    my $self = shift;
    return _GetClassName($self->{obj});
}

sub GetProperty {
    my $self = shift;
    my $prop_name = shift;

    my $val = $self->{obj}->_GetProperty($prop_name);
    my $type = $self->{obj}->_GetPropertyType($prop_name);
    if($type > 8192){
    	return $val->_GetAV($type);
    } else {
	return $val->_GetSV($type);
    }
}


1;
