# -*- perl -*-
#
# Copyright (C) 2005-2009 Nexenta
#

package Net::WMI::Connection;

use 5.006;
use strict;
use warnings;

use Net::WMI;
use Net::WMI::EnumClassObject;
use Net::WMI::IClassObject;
use Net::WMI::ClassObject;

sub new {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my %params = @_;
    my $self = {};

    my $hostname = exists $params{hostname} ? $params{hostname} :  die "hostname parameter is required";
    my $namespace = exists $params{namespace} ? $params{namespace} :  die "namespace parameter is required";
    my $user = exists $params{user} ? $params{user} :  die "user parameter is required";
    my $pass = exists $params{pass} ? $params{pass} :  die "pass parameter is required";

    $self->{con} = Net::WMI::Connection::_ConnectServer($hostname,$namespace,$user,$pass);
    bless $self, $class;
    return $self;
}

sub ExecQuery {
    my $self = shift;
    my $enum =  _ExecQuery($self->{con},shift);
    return Net::WMI::EnumClassObject->new(enum => $enum);
}

sub ExecNotificationQuery {
    my $self = shift;
    my $enum =  _ExecNotificationQuery($self->{con},shift);
    return Net::WMI::EnumClassObject->new(enum => $enum);
}


sub ExecMethod {
    my $self = shift;
    my $objname = shift;
    my $method = shift;
    my $inobj = shift;
    my $obj =  _ExecMethod($self->{con},$objname,$method,$inobj);

    return Net::WMI::IClassObject->new(obj => $obj);
}

sub ExecMethod1 {
    my $self = shift;
    my $objname = shift;
    my $method = shift;
    my $obj =  _ExecMethod1($self->{con},$objname,$method);
    return Net::WMI::IClassObject->new(obj => $obj);
}

sub GetObject {
    my $self = shift;
    my $obj =  _GetObject($self->{con},shift);
    return Net::WMI::IClassObject->new(obj => $obj);
}


1;
