# -*- perl -*-
#
# Copyright (C) 2005-2009 Nexenta
#

package Net::WMI::EnumClassObject;

use 5.006;
use strict;
use warnings;
use Net::WMI::ClassObject;
use Net::WMI::IClassObject;

sub new {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my %params = @_;
    my $self = {};

    $self->{enum} = exists $params{enum} ? $params{enum} : die "enum parameter is required";

    bless $self, $class;

    return $self;
}

sub Reset {
    my $self = shift;
    _Reset($self->{enum});
}

sub Next {
    my $self = shift;
    my $obj = _Next($self->{enum});
    if(defined $obj){
        return Net::WMI::ClassObject->new( obj => $obj);
    }
    else {
        return undef;
    }
}


1;
