# -*- perl -*-
#
# Copyright (C) 2005-2009 Nexenta
#
package Net::WMI::Error;

use strict;
use warnings;


use overload ('""' => 'stringify');

sub new {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {};
    my %params = @_;

    $self->{name} = $params{name} ? $params{name} : die "name parameter is required";
    $self->{message} = $params{message} ? $params{message} : die "message parameter is required";

    bless $self, $class;

    return $self;
}

sub name {
    my $self = shift;
    return $self->{name};
}

sub message {
    my $self = shift;
    return $self->{message};
}

sub stringify {
    my $self = shift;

    return $self->{name} . ": " . $self->{message} . ($self->{message} =~ /\n$/ ? "" : "\n");
}


1;
