# -*- perl -*-
#
# Copyright (C) 2005-2009 Nexenta
#

package Net::WMI::IClassObject;

use 5.006;
use strict;
use warnings;

sub new {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my %params = @_;
    my $self = {};

    $self->{obj} = exists $params{obj} ? $params{obj} : die "obj parameter is required";

    bless $self, $class;

    return $self;
}

sub GetClassName {
    my $self = shift;
}

sub GetMethod {
    my $self = shift;
    my ($in, $out) = _GetMethod($self->{obj},shift);
    return ( Net::WMI::IClassObject->new(obj => $in), Net::WMI::IClassObject->new(obj => $out));
}

sub SpawnInstance {
    my $self = shift;
    my $out = _SpawnInstance($self->{obj});
    return Net::WMI::IClassObject->new(obj => $out);
}

sub GetClassObject {
    my $self = shift;
    my $out = _GetClassObject($self->{obj});
    return Net::WMI::ClassObject->new(obj => $out);
}


sub ListMethods {
    my $self = shift;
    my $out = _ListMethods($self->{obj});
}

sub ListProperties {
    my $self = shift;
    return _ListProperties($self->{obj});
}

sub Put {
    my $self = shift;
    my $name = shift;
    my $val = shift;
    _Put($self->{obj},$name,$val);
}

1;
